diff --git a/libAfterBase/configure.in b/libAfterBase/configure.in
index de055ea..eb5619e 100644
--- a/libAfterBase/configure.in
+++ b/libAfterBase/configure.in
@@ -189,6 +189,8 @@ AC_CHECK_HEADERS(elf.h,[AC_CHECK_DECLS([ElfW],,,[#include <link.h>])
 			AC_CHECK_MEMBERS([Elf32_Dyn.d_tag, Elf64_Dyn.d_tag],,,[#include <elf.h>])
 			AC_CHECK_TYPES([Elf64_Addr, Elf32_Addr],,,[#include <elf.h>])])
 
+AC_CHECK_LIB([execinfo], [backtrace], [LIBS="$LIBS -lexecinfo"; lib_execinfo="-lexecinfo"])
+
 dnl# this is needed for self diagnostic code :
 AC_CHECK_FUNCS(backtrace_symbols_fd backtrace_symbols backtrace)
 
@@ -257,6 +257,7 @@ AC_SUBST(lib_file_name)
 AC_SUBST(with_locale)
 AC_SUBST(user_ldflags)
 AC_SUBST(x_libs)
+AC_SUBST(lib_execinfo)
 AC_SUBST(X_CFLAGS)
 AC_SUBST(LIBPROG)
 AC_SUBST(LIBINSTALL)
diff --git a/libAfterBase/Makefile.in b/libAfterBase/Makefile.in
index f04be29..c3bacbb 100644
--- a/libAfterBase/Makefile.in
+++ b/libAfterBase/Makefile.in
@@ -80,6 +80,7 @@ INCLUDES	= $(INCS_X) $(INCS_PRIVATE)
 
 USER_LD_FLAGS	= @user_ldflags@
 LIBS_X		= @x_libs@
+LIB_EXECINFO	= @lib_execinfo@
 
 
 LIBDIR		= $(DESTDIR)@libdir@
@@ -326,7 +327,7 @@ $(LIB_SHARED).$(LIBVERMAJOR): $(LIB_SHARED).$(LIBVER)
 
 $(LIB_SHARED).$(LIBVER): $(LIB_OBJS) $(LIB_INCS)
 	$(CC) -shared $(LDFLAGS) -Wl,-soname,$(LIB_SHARED).$(LIBVERMAJOR) -o $(LIB_SHARED).$(LIBVER) \
-	 $(USER_LD_FLAGS) $(LIBS_X) $(LIB_OBJS)
+	 $(USER_LD_FLAGS) $(LIB_OBJS) $(LIBS_X) $(LIB_EXECINFO)
 
 install:	install.lib
 
diff --git a/autoconf/Makefile.defines.in b/autoconf/Makefile.defines.in
index e6c283f..f8cae5e 100644
--- a/autoconf/Makefile.defines.in
+++ b/autoconf/Makefile.defines.in
@@ -40,6 +40,7 @@ LIBS_READLINE	= @readline_libs@
 LIBS_X		= @x_libs@
 LIBS_ALSA	= @ALSA_LIBS@
 LIBS_XEXTS	=
+LIB_EXECINFO	= @lib_execinfo@
 LIB_AFTERBASE	= @AFTERBASE_LIB@
 LIB_AFTERIMAGE	= @AFTERIMAGE_LIB@
 LIB_AFTERSTEP	= @AFTERSTEP_LIB@
@@ -53,7 +54,7 @@ LIB_AFTERCONF_STATIC   = @AFTERCONF_STATIC_LIB@
 LIB_ASGTK_STATIC   = @ASGTK_STATIC_LIB@
 LIB_WIDGETS_STATIC     = @WIDGETS_STATIC_LIB@
 LIBS_AFTERIMAGE = @AFTERIMAGE_LIBS@
-LIBRARIES	= $(USER_LD_FLAGS) $(LIBS_PRIVATE) $(LIBS_XEXTS) $(LIBS_X)
+LIBRARIES	= $(USER_LD_FLAGS) $(LIBS_PRIVATE) $(LIBS_XEXTS) $(LIBS_X) $(LIB_EXECINFO)
 
 LIBS_ALL	= $(LIBRARIES) $(EXTRA_LIBRARIES)
 
diff --git a/autoconf/configure.in b/autoconf/configure.in
index 45add70..4170f98 100644
--- a/autoconf/configure.in
+++ b/autoconf/configure.in
@@ -651,6 +651,8 @@ if test "x$send_postcard_to_developer" = "xyes"; then
 	AC_DEFINE(DO_SEND_POSTCARD,1,E-mail installation notification to AfterStep developers)
 fi
 
+AC_CHECK_LIB([execinfo],[backtrace],[lib_execinfo="-lexecinfo"])
+
 AC_CANONICAL_TARGET
 AC_SUBST(build)
 AC_SUBST(build_os)
@@ -718,6 +720,7 @@ AC_SUBST(with_desktops)
 AC_SUBST(with_desktops_1)
 AC_SUBST(with_deskgeometry)
 AC_SUBST(no_data_reinstall)
+AC_SUBST(lib_execinfo)
 dnl# old stuff :
 AC_SUBST(enable_different_looknfeels)
 AC_SUBST(enable_pagerbackground)
